Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0038676
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Retail Modules] Web POSmajoralways2018-05-31 19:092018-08-03 08:03
ReportermarvintmView Statuspublic 
Assigned Toranjith_qualiantech_com 
PrioritynormalResolutionfixedFixed in VersionRR18Q3
StatusclosedFix in branchFixed in SCM revision5de50a74a0d2
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned Tomarvintm
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0038676: Ticket completion should be executed fully inside the same database transaction, and currently that's not the case

DescriptionThe ticket completion process, which involves:
- updating the order record in the local database
- updating the cashup report information
- updating the document sequence in the local database

should be fully executed in the same database transaction. However, currently the process is broken into two different transactions, and this means that if the user closes the browser, or refreshes the page while the process is being executed, some part of it may be committed, while some other part is yet pending to be completed.
Steps To Reproduce- Place a breakpoint in the following js line:

receipt.set('json', JSON.stringify(receipt.serializeToJSON()));

which is part of the mainReceiptCloseFunction.
- Complete a ticket in the WebPOS.
- After the flow stops in the breakpoint, refresh the WebPOS (F5)
- Notice that the data is not correct anymore.
Proposed Solution- The second transaction(trx) should be removed.
- All code should use the initial transaction (tx).
- The OBPOS_PreSyncReceipt should receive this transaction.
- Current French certification modules should be changed to use this transaction which they will now receive in the hook.
TagsNo tags attached.
Attached Files

- Relationships Relation Graph ] Dependency Graph ]
depends on backport 0038770RR18Q2.1 closedranjith_qualiantech_com Ticket completion should be executed fully inside the same database transaction, and currently that's not the case 
related to defect 0038862 closedmigueldejuana Ticket completion should be executed fully inside the same database transaction 

-  Notes
(0104912)
hgbot (developer)
2018-06-04 13:15

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: 47ec4987197c0f3172353016e42ddc7406e260f4
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Mon Jun 04 16:44:29 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/47ec4987197c0f3172353016e42ddc7406e260f4 [^]

Fixed issue 38676 : Removed Additional Transaction before syncing receipt to backoffice

* Previously for PreSyncReceipt hook, Additional Transaction has been added before syncing receipt to backoffice.
  Now Additional Transaction is removed and transaction is passed as param in PreSyncReceipt hook

---
M web/org.openbravo.retail.posterminal/js/data/dataordersave.js
---
(0104919)
hgbot (developer)
2018-06-04 14:38

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: 09680bdda4f5fe9a572be0deeac0d670123b924b
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Mon Jun 04 18:07:57 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/09680bdda4f5fe9a572be0deeac0d670123b924b [^]

Related to issue 38676 : PreSyncReceipt Transactions should be changed in dependent modules

Backed out changeset: 47ec4987197c

---
M web/org.openbravo.retail.posterminal/js/data/dataordersave.js
---
(0105022)
hgbot (developer)
2018-06-08 07:39

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: f7d2963fe467476e41261e614ba94611e1171681
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Fri Jun 08 11:09:11 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/f7d2963fe467476e41261e614ba94611e1171681 [^]

Related to issue 38676 : Removed Additional Transaction before syncing receipt to backoffice

* Previously for PreSyncReceipt hook, Additional Transaction has been added before syncing receipt to backoffice.
  Now Additional Transaction is removed and transaction is passed as param in PreSyncReceipt hook

---
M web/org.openbravo.retail.posterminal/js/data/dataordersave.js
---
(0105257)
ranjith_qualiantech_com (developer)
2018-06-19 14:28

Changes are not correct. args.transaction should be used instead of args.tx.
(0105300)
hgbot (developer)
2018-06-21 12:04

Repository: erp/pmods/org.openbravo.retail.complementary
Changeset: 041a9e93477982a512437d92c29e4a83575a1364
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Thu Jun 21 15:34:36 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.complementary/rev/041a9e93477982a512437d92c29e4a83575a1364 [^]

Related to issue 38676 : Added currentTransaction to OBPOS_PostAddProductToOrder hook

* If currentTransaction is presents in product options, it should be used to fetch the Complementary Products

---
M web/org.openbravo.retail.complementary/js/hooks/hookRenderOrderLine.js
---
(0105301)
hgbot (developer)
2018-06-21 12:05

Repository: erp/pmods/org.openbravo.certification.france
Changeset: 187e515a0dac98f77debfaae8b9f5ebc2c350031
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Thu Jun 21 15:35:24 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.certification.france/rev/187e515a0dac98f77debfaae8b9f5ebc2c350031 [^]

Related to issue 38676 : Added PreSyncReceipt hook transaction

* Set "preventOrderSave" to true, for not to save the cancel receipt in local db
* Added PreSyncReceipt hook transaction to OB.Dal methods

---
M web/org.openbravo.certification.france/js/ticket/preSyncReceiptHook.js
---
(0105303)
hgbot (developer)
2018-06-21 13:38

Repository: erp/pmods/org.openbravo.certification.france
Changeset: 1254908b83bccfbe64f1d83e6268a362afea0edd
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Thu Jun 21 17:08:36 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.certification.france/rev/1254908b83bccfbe64f1d83e6268a362afea0edd [^]

Related to issue 38676 : Added PreSyncReceipt hook transaction

Tests were failed in try-retail
Backed out changeset: 187e515a0dac

---
M web/org.openbravo.certification.france/js/ticket/preSyncReceiptHook.js
---
(0105459)
hgbot (developer)
2018-06-27 08:47

Repository: erp/pmods/org.openbravo.retail.posterminal
Changeset: 5de50a74a0d2f3ff03b07af7fc8efec6a4a4abb0
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Wed Jun 27 12:16:33 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/5de50a74a0d2f3ff03b07af7fc8efec6a4a4abb0 [^]

Fixed issue 38676 : PreSyncReceipt hook should be called when the transaction completes

* Hook "OBPOS_PreSyncReceipt" should be called when receipt save transaction completes
* In Hook Callback, receipt must be saved again and sync process should be called

---
M web/org.openbravo.retail.posterminal/js/data/dataordersave.js
---
(0105505)
marvintm (developer)
2018-06-29 09:23

With the latest changes, everything happens in the same transaction except for the last save at the end. This part can be improved, but the current solution is enough for now.
(0106127)
hgbot (developer)
2018-08-03 08:03

Repository: erp/pmods/org.openbravo.retail.complementary
Changeset: fb8c4bba5876c4338734de333865ead457c1bcbd
Author: Ranjith S R <ranjith <at> qualiantech.com>
Date: Thu Aug 02 16:03:02 2018 +0530
URL: http://code.openbravo.com/erp/pmods/org.openbravo.retail.complementary/rev/fb8c4bba5876c4338734de333865ead457c1bcbd [^]

Related to issue 38676 : Backed out changeset: 041a9e934779

---
M web/org.openbravo.retail.complementary/js/hooks/hookRenderOrderLine.js
---

- Issue History
Date Modified Username Field Change
2018-05-31 19:09 marvintm New Issue
2018-05-31 19:09 marvintm Assigned To => Retail
2018-05-31 19:09 marvintm Triggers an Emergency Pack => No
2018-05-31 19:19 marvintm Assigned To Retail => ranjith_qualiantech_com
2018-06-01 07:15 ranjith_qualiantech_com Status new => scheduled
2018-06-04 13:15 hgbot Checkin
2018-06-04 13:15 hgbot Note Added: 0104912
2018-06-04 13:15 hgbot Status scheduled => resolved
2018-06-04 13:15 hgbot Resolution open => fixed
2018-06-04 13:15 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/47ec4987197c0f3172353016e42ddc7406e260f4 [^]
2018-06-04 14:38 hgbot Checkin
2018-06-04 14:38 hgbot Note Added: 0104919
2018-06-04 14:38 ranjith_qualiantech_com Status resolved => new
2018-06-04 14:38 ranjith_qualiantech_com Resolution fixed => open
2018-06-04 14:38 ranjith_qualiantech_com Status new => scheduled
2018-06-08 07:39 hgbot Checkin
2018-06-08 07:39 hgbot Note Added: 0105022
2018-06-11 08:14 ranjith_qualiantech_com Status scheduled => resolved
2018-06-11 08:14 ranjith_qualiantech_com Resolution open => fixed
2018-06-15 14:44 marvintm Status resolved => new
2018-06-15 14:44 marvintm Resolution fixed => open
2018-06-15 14:44 marvintm Status new => scheduled
2018-06-15 14:44 marvintm Status scheduled => resolved
2018-06-15 14:44 marvintm Fixed in Version => RR18Q3
2018-06-15 14:44 marvintm Resolution open => fixed
2018-06-15 14:44 marvintm Review Assigned To => marvintm
2018-06-15 14:44 marvintm Status resolved => closed
2018-06-19 14:28 ranjith_qualiantech_com Note Added: 0105257
2018-06-19 14:28 ranjith_qualiantech_com Status closed => new
2018-06-19 14:28 ranjith_qualiantech_com Resolution fixed => open
2018-06-19 14:28 ranjith_qualiantech_com Fixed in Version RR18Q3 =>
2018-06-19 14:28 ranjith_qualiantech_com Status new => scheduled
2018-06-21 12:04 hgbot Checkin
2018-06-21 12:04 hgbot Note Added: 0105300
2018-06-21 12:05 hgbot Checkin
2018-06-21 12:05 hgbot Note Added: 0105301
2018-06-21 13:38 hgbot Checkin
2018-06-21 13:38 hgbot Note Added: 0105303
2018-06-26 10:12 migueldejuana Assigned To ranjith_qualiantech_com => migueldejuana
2018-06-26 12:54 marvintm Assigned To migueldejuana => ranjith_qualiantech_com
2018-06-27 08:47 hgbot Checkin
2018-06-27 08:47 hgbot Note Added: 0105459
2018-06-27 08:47 hgbot Status scheduled => resolved
2018-06-27 08:47 hgbot Resolution open => fixed
2018-06-27 08:47 hgbot Fixed in SCM revision http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/47ec4987197c0f3172353016e42ddc7406e260f4 [^] => http://code.openbravo.com/erp/pmods/org.openbravo.retail.posterminal/rev/5de50a74a0d2f3ff03b07af7fc8efec6a4a4abb0 [^]
2018-06-29 09:23 marvintm Note Added: 0105505
2018-06-29 09:23 marvintm Status resolved => closed
2018-06-29 09:23 marvintm Fixed in Version => RR18Q3
2018-06-29 09:25 marvintm Relationship added related to 0038862
2018-08-03 08:03 hgbot Checkin
2018-08-03 08:03 hgbot Note Added: 0106127


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker